"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.injectToDependencies = exports.createDependencies = void 0;
var ajax_1 = require("rxjs/ajax");
var createDependencies = function (_a) {
    var _b = _a.dependencies, dependencies = _b === void 0 ? {} : _b, _c = _a.headers, headers = _c === void 0 ? function (action$, state$, method, url, data, options) { return ({
        'Content-Type': 'application/json',
    }); } : _c;
    return ({
        dependencies: __assign({ get: function (action$, state$, url, data, options) {
                var pdata = Object.keys(data).reduce(function (meno, key) {
                    var _a;
                    if (key && data[key] != null && data[key] != '') {
                        return __assign(__assign({}, meno), (_a = {}, _a[key] = data[key], _a));
                    }
                    return meno;
                }, {});
                var params = new URLSearchParams(pdata);
                return (0, ajax_1.ajax)({
                    url: "".concat(url).concat(url.includes('?') ? '&' : '?').concat(params.toString()),
                    method: 'GET',
                    headers: headers(action$, state$, 'GET', url, data, options),
                });
            }, post: function (action$, state$, url, data, options) {
                return (0, ajax_1.ajax)({
                    url: url,
                    method: 'POST',
                    headers: headers(action$, state$, 'POST', url, data, options),
                    body: data,
                });
            }, put: function (action$, state$, url, data, options) {
                return (0, ajax_1.ajax)({
                    url: url,
                    method: 'PUT',
                    headers: headers(action$, state$, 'PUT', url, data, options),
                    body: data,
                });
            }, del: function (action$, state$, url, data, options) {
                return (0, ajax_1.ajax)({
                    url: url,
                    method: 'DELETE',
                    headers: headers(action$, state$, 'DELETE', url, data, options),
                    body: data,
                });
            } }, dependencies),
    });
};
exports.createDependencies = createDependencies;
var injectToDependencies = function (rootEpic) {
    return function (action$, state$, dependencies) {
        if (dependencies === void 0) { dependencies = {}; }
        var _loop_1 = function (dependency) {
            if (dependencies.hasOwnProperty(dependency)) {
                var dependencyValue_1 = dependencies[dependency];
                if (typeof dependencyValue_1 === 'function') {
                    dependencies[dependency] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        return dependencyValue_1.apply(void 0, __spreadArray([action$, state$], args, false));
                    };
                }
            }
        };
        for (var dependency in dependencies) {
            _loop_1(dependency);
        }
        return rootEpic(action$, state$, dependencies);
    };
};
exports.injectToDependencies = injectToDependencies;
