"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeState = exports.updateStateIn = exports.updateState = exports.getStateIn = exports.getState = void 0;
var getState = function (state, keyPath, defaultValue) {
    var _a, _b;
    if (state === void 0) { state = {}; }
    if (typeof keyPath === 'string' || typeof keyPath === 'number') {
        keyPath = [keyPath];
    }
    var key = keyPath.shift();
    var subState = (_a = state[key]) !== null && _a !== void 0 ? _a : {};
    if (keyPath.length === 0) {
        return (_b = state[key]) !== null && _b !== void 0 ? _b : defaultValue;
    }
    if (typeof subState !== 'object') {
        subState = {};
    }
    return (0, exports.getState)(subState, keyPath, defaultValue);
};
exports.getState = getState;
var getStateIn = function (state, keyPath, fn, defaultValue) {
    var _a;
    if (state === void 0) { state = {}; }
    if (typeof keyPath === 'string' || typeof keyPath === 'number') {
        keyPath = [keyPath];
    }
    var key = keyPath.shift();
    var subState = (_a = state[key]) !== null && _a !== void 0 ? _a : {};
    if (keyPath.length === 0) {
        try {
            return fn(state[key]);
        }
        catch (e) {
            return defaultValue;
        }
    }
    if (typeof subState !== 'object') {
        subState = {};
    }
    return (0, exports.getStateIn)(subState, keyPath, fn, defaultValue);
};
exports.getStateIn = getStateIn;
var updateState = function (state, keyPath, value) {
    var _a;
    var _b;
    if (state === void 0) { state = {}; }
    if (typeof keyPath === 'string' || typeof keyPath === 'number') {
        keyPath = [keyPath];
    }
    if (keyPath.length === 0) {
        return value;
    }
    var key = keyPath.shift();
    var subState = (_b = state[key]) !== null && _b !== void 0 ? _b : {};
    if (typeof subState !== 'object') {
        subState = {};
    }
    return __assign(__assign({}, state), (_a = {}, _a[key] = (0, exports.updateState)(subState, keyPath, value), _a));
};
exports.updateState = updateState;
var updateStateIn = function (state, keyPath, fn) {
    var _a, _b;
    var _c;
    if (state === void 0) { state = {}; }
    if (typeof keyPath === 'string' || typeof keyPath === 'number') {
        keyPath = [keyPath];
    }
    var key = keyPath.shift();
    if (keyPath.length === 0) {
        try {
            return __assign(__assign({}, state), (_a = {}, _a[key] = fn(state[key]), _a));
        }
        catch (e) {
            return state;
        }
    }
    var subState = (_c = state[key]) !== null && _c !== void 0 ? _c : {};
    if (typeof subState !== 'object') {
        subState = {};
    }
    return __assign(__assign({}, state), (_b = {}, _b[key] = (0, exports.updateStateIn)(subState, keyPath, fn), _b));
};
exports.updateStateIn = updateStateIn;
var removeState = function (state, keyPath) {
    var _a;
    var _b;
    if (state === void 0) { state = {}; }
    if (typeof keyPath === 'string' || typeof keyPath === 'number') {
        keyPath = [keyPath];
    }
    var key = keyPath.shift();
    if (keyPath.length === 0) {
        return Object.keys(state).reduce(function (m, n) {
            if (n === key)
                return m;
            m[n] = state[n];
            return m;
        }, {});
    }
    var subState = (0, exports.removeState)(((_b = state[key]) !== null && _b !== void 0 ? _b : {}), keyPath);
    // remove key if it doesnot has any child
    if (Object.keys(subState).length === 0) {
        return Object.keys(state).reduce(function (m, n) {
            if (n === key)
                return m;
            m[n] = state[n];
            return m;
        }, {});
    }
    return __assign(__assign({}, state), (_a = {}, _a[key] = subState, _a));
};
exports.removeState = removeState;
