import { ajax } from 'rxjs/ajax';
export const createDependencies = ({ dependencies = {}, headers = (action$, state$, method, url, data, options) => ({
    'Content-Type': 'application/json',
}), }) => ({
    dependencies: {
        get: (action$, state$, url, data, options) => {
            const pdata = Object.keys(data).reduce((meno, key) => {
                if (key && data[key] != null && data[key] != '') {
                    return { ...meno, [key]: data[key] };
                }
                return meno;
            }, {});
            const params = new URLSearchParams(pdata);
            return ajax({
                url: `${url}${url.includes('?') ? '&' : '?'}${params.toString()}`,
                method: 'GET',
                headers: headers(action$, state$, 'GET', url, data, options),
            });
        },
        post: (action$, state$, url, data, options) => {
            return ajax({
                url,
                method: 'POST',
                headers: headers(action$, state$, 'POST', url, data, options),
                body: data,
            });
        },
        put: (action$, state$, url, data, options) => {
            return ajax({
                url,
                method: 'PUT',
                headers: headers(action$, state$, 'PUT', url, data, options),
                body: data,
            });
        },
        del: (action$, state$, url, data, options) => {
            return ajax({
                url,
                method: 'DELETE',
                headers: headers(action$, state$, 'DELETE', url, data, options),
                body: data,
            });
        },
        ...dependencies,
    },
});
export const injectToDependencies = (rootEpic) => {
    return (action$, state$, dependencies = {}) => {
        for (const dependency in dependencies) {
            if (dependencies.hasOwnProperty(dependency)) {
                const dependencyValue = dependencies[dependency];
                if (typeof dependencyValue === 'function') {
                    dependencies[dependency] = (...args) => dependencyValue(action$, state$, ...args);
                }
            }
        }
        return rootEpic(action$, state$, dependencies);
    };
};
